: TW.BAT --- Main Part of TW2002 Enhancement Batch  --> REQUIRES 4DOS 4.0(+)!
:
: ͻ
: Kris Lewis, FidoNet 1:202/613  (c) 1991-1992                             
:                                                                          
: Format: [CALL] TW [game-letter action]                                   
:                                                                          
: With no or wrong parameters, gives a reminder of the command-line format 
:                                                                          
: The CALL is to be used from the BBS control batchfile to CALL this batch 
: for gameplay, automated maint or setup.                                  
:                                                                          
: [game-letter] - any valid game indicator. See end of file remarks.       
:                                                                          
: [action]      - can be any of:                                           
:      MAINT       - Run maintenance, including Extern, over the specified 
:                    game.                                                 
:      EDIT(255)   - Edit a game. This can be altered via TWENH.CFG file.  
:      DOOR        - Run the game in BBS DOOR mode.  (Environment variable 
:                    %Infotype determines mode and is as per TW2002.DOC, & 
:                    set by TWENH.CFG)                                     
:      SETUP       - Create a new universe, optionally make/stock The Wan- 
:                    derer, a Nexus and random planets.                    
:                                                                          
: Upon Exit, the following ErrorLevels have validity:                      
:                                                                          
:    0 - No errors. Normal completion                                      
:    1 - Invalid Game Indicator                                            
:    2 - Invalid Action Code                                               
:   10 - No Registration code, and no old datafile to read it from         
:   20 - No decompression software found (compressed mode)                 
:   30 - No compression software found (compressed mode)                   
:  100 - Cannot find TWENH.CFG                                             
:        Cannot find BIGBANG.CFG (no prob. just warns & uses defaults)     
:        Cannot find MAINT.CFG (no prob. just warns & uses defaults)       
:  200 - Cannot find Door drop file (DOOR.SYS or equivalent)               
:  250 - TWENH envvar not set or invalid and programs not on path          
:  251 - TW2002 not present in TWENH directory                             
:  252 - TWENH dir pointer invalid (does not exist)                        
:  255 - Miscellaneous error. Usually explained                            
:                                                                          
:   (If one exists, TW [game] SETUP will read an old game's TWDATA.DAT for 
:    the info on screens G and H.)                                         
: ͼ
:
:
:
:
: ͻ
:   Ŀ Ŀ Ŀ Ŀ       Ŀ       Ŀ Ŀ  
:                                                             
:                                                             
:                                                              
:    Ĵ    Ĵ                    Ĵ        Ŀ  
:                                                             
:                                                             
:                                                             
:                                       
: This batch is made available for your use free, PROVIDED:                
:  1 - No alterations are made. If you want a change, tell me and *I* will 
:      do it. Route suggestions to Sysop, 202/613 or Moderator, TRADE_WARS.
:  2 - Any distribution of this code must include everything that was in   
:      the original package as I carry it. It may be re-packaged, but ALL  
:      files must be included, and NO extras. THIS INCLUDES STUPID LITTLE  
:      BBS ADS! I reserve the right to charge you $20 if I find a BBS ad!  
:      Advertising constitutes acceptance of debt, to be paid on demand.   
:      (I include ZipComments and the equivalent for other archivers.)     
:  3 - Due credit for the expanded features is given. Failing credit, just 
:      don't claim this as your own work. I put a LOT of time in it!       
: Ŀ
:  See end of the file for a list of factors the batch file depends on.  
: ϼ
: ͻ
:   Ŀ Ŀ Ŀ        Ŀ                               
:                                                                  
:                                                                  
:                                                                   
:   Ŀ Ĵ                                                 
:                                                                    
:                                                                   
:                                                                   
:                                                   
: ͼ
 SetLocal
 Iff %# NE 2 Then
    Echo Format: TW game-letter action
    Quit 255
 EndIff

 If %@Len[%TWEnh] EQ 0 Set TWEnh=%@Path[%@Search[TW.Bat]]

 Iff %@Len[%TWEnh] EQ 0 Then
    Text
TW must be on the path OR environment variable "TWENH" must be set. This is a 
directory pointer to TWEnh to "find" itself and TradeWars 2002. I REQUIRE that 
the enhancer files co-exist with the actual game's EXE/OVR files. ex:
Set TWENH=E:\Door\Tradewar\ 
    EndText
    Quit 250
 EndIff

 Iff IsDir %TWEnh Then
    PushD %TWEnh
    Iff Not Exist TW2002.EXE Then
       Text
TW2002.EXE not found. The TWEnhancer must reside in the same sub-dir as 
TW2002's .EXE/.OVR, TEDIT, and EXTERN. This is also the directory that TWEnh 
will use to store the inactive games, if compressed, and the static files
uncompressed in either mode. 
       EndText
       Quit 251
    EndIff
  Else
    Echo Invalid TWENH directory: %TWEnh does not exist.
    Quit 252
 EndIff
 If %@SubStr[%TWEnh,0,-1] NE \ Set TWEnh=%TWEnh\
:
 Iff Not IsAlias Rand Then
    If Not Exist Aliases.TW Copy %@Search[Aliases.TW]
    Iff Exist Aliases.TW Then
          Alias/r Aliases.TW 
       Else
          Text
TWEnhance is programmed in 4DOS's batch language with aliasing for ease of
debugging as well as brevity (yea, right!). The file ALIASES.TW, included
in TWENH*.ZIP, MUST be present on the path (preferably in directory %TWEnh)
if it is not loaded before TWEnhance is called.
          EndText
          Quit 255
    EndIff
 EndIff
:
 If %@Len[%@Search[Waits.Set]] EQ 0 Call TestVid
 PSet Waits.Set
:
 Set Game=%@Upper[%1]
 Set Act=%@Upper[%2]
:
 Set W=/W20
 Set ConfLoaded=N
 Set MaintLoaded=N
 Set CreateLoaded=N
 Set BBS=J:\
 Set BBSName=Traders World!
 Set Voice=619-284-7926
 Set InfoFile=Door.Sys
 Set InfoType=DOOR
 Set LocalPlay=OK
 Set MaxSH=1638
 Set Ragnarok=Destroy
 Set MSLBcn=Y
 Set MSLReBcn=N
 Set Satellite=N
 Set BlackHoleDays=30
 Set BlackHoleChance=0.9999
 Set BlackHoleLog=Sector
 Set Ferrengi=Y
 Set Rogues=Y
 Set Wanderer=Y
 Set WRDays=8
 Set Entity=5
 Set EntityCit=1
 Set EntityShlds=750
 Set EntityStun=5
 Set EntityMine=6
 Set EntityDStar=Y
 Set DStar=30
 Set DSLitter=0.3300
 Set DSLInc=0.0050
 Set EvilISS=RA
 Set EvilISSWeight=0.7500
 Set TurnsDay=60
 Set LogLines=800
 Set UseCTS=N
 Set LocalView=N
 Set AMove=10
 Set FMove=10
 Set PhotonDur=20
 Set Squatters=5
 Set SysopLevel=100
 Set VStarDock=0.5000
 Set Nexus=.8175
 Set NexNebula=The Nexus
 Set NexInterval=4
 Set NexAlter=0.9999
 Set Wanderer=Y
 Set DStar=30
 Set PMin=5
 Set PMax=25

 PSet TWEnh.Cfg
 PSet TWEnh.%Game
 PSet Maint.Cfg
 PSet Maint.%Game
 PSet BigBang.Cfg
 PSet BigBang.%Game

 Iff %ConfLoaded EQ N Then
    Echo Cannot locate TWENH.CFG (searching entire path)
    Quit 100
 EndIff

 If %@Len[%Out] LT 1 Set Out=COM1
 If %@Len[%Editor] EQ 0 Set Editor=EDIT
 If %Act EQ %Editor Set Act=Editor
:
 Iff Not IsDir %Game .AND. Not Exist 2002-%Game.* Then
    Echo Invalid game indicator
    Quit 1
 EndIff
:
: Auto-detect Compressed mode or not... If Compressed, figure out with what
: software and set up the commands.
:
 Set CompUse=Y
 If IsDir %Game Set CompUse=N
 Iff %CompUse EQ Y Then
    Set Ext=%@Ext[2002-%Game.*]
    SelectCase Ext
       Case EQ ZIP
          Set CompNot=PKUnZip 
          Set CompAdd=PKZip -a 
          Set CompUpd=PKZip -f 
       Case EQ LZH
          Set CompNot=Lha e 
          Set CompAdd=Lha a 
          Set CompUpd=Lha f 
       Case EQ ZOO
          Set CompNot=Zoo e 
          Set CompAdd=Zoo a 
          Set CompUpd=Zoo f 
       Case EQ ARC
          Set CompNot=PKUnPak 
          Set CompAdd=PKPak -a 
          Set CompUpd=PKPak -f 
       Case EQ PAK
          Set CompNot=Pak e 
          Set CompAdd=Pak a 
          Set CompUpd=Pak u 
       CaseElse
          Echo %Ext not recognized.
    EndSelect
    Iff %@Len[%@Search[%@Word[0,%CompNot].[ec][xo][em]]] EQ 0 Then
       Echo Decompression software not found on path.
       Quit 20
    EndIff
    Iff %@Len[%@Search[%@Word[0,%CompAdd].[ec][xo][em]]] EQ 0 Then
       Echo Compression software not found on path.
       Quit 30
    EndIff
 EndIff
:
: Keep a copy of the original ships, but allow the use of altered ships. These
: altered shipstat.dats need to be treated as dynamic files stored with TWDATA
: etc.
:
 Iff Not Exist ShipStat.Org Then
    Copy/Q ShipStat.Dat ShipStat.Org
  Else
    Copy/Q ShipStat.Org ShipStat.Dat
 EndIff
:
 Iff %Act NE SETUP Then
    SelectCase CompUse
       Case EQ Y
          %CompNot 2002-%Game SysRules.Tw
          If Exist SysRules.TW .AND. %Act EQ DOOR Copy/Q SysRules.TW %Out
          %CompNot 2002-%Game
       CaseElse
          If Exist %Game%\SysRules.TW .AND. %Act EQ DOOR Copy/Q %Game%\SysRules.TW %Out
          Copy/Q %Game
    EndSelect
 EndIff
: Ŀ
: Test and setup accordingly for SETUP, EDIT and MAINT                     
: 
 Iff %Act NE DOOR .AND. %@Len[%Act] GT 1 Then
    Copy/Q Local.DIF %InfoFile
    Goto %Act
 EndIff
: Ŀ
: This section handles local playing and depends on canned Door Info Files 
: in the directory named [name].DIF for each local player. All the code    
: does is pick and rename the proper Door Info File.                       
: 
 Iff %LocalPlay EQ OK .AND. %@Len[%2] EQ 1 Then
    Except (Local.DIF) Dir/BDJC *.DIF>Names.Lst^Set Name=%@Line[Names.Lst,0]
    Iff %@Lines[Names.Lst] GT 0 Then 
      :GetName
          Cls^Beep^Echo Pick which is for you!^Set Name=%@Select[Names.Lst,2,60,%@Eval[%@Lines[Names.Lst]+4],69,Your data?]
       Loop GetName Until %@Len[%Name] GT 0
    EndIff
    Ren %Name %InfoFile^Except (Local.DIF) Del/QY Names.Lst *.DIF>&Nul^Set Act=Lcl
 EndIff
 Uns LocalPlay
:
 Goto %Act
:
:Editor
:
 TEdit -%Infotype 
 Goto Repack
:
:
:Door
:
 If Not Exist %InfoFile .AND. %@Len[%@Search[%InfoFile]] GT 0 Copy/Q %@Search[%InfoFile]
 If Not Exist %InfoFile If %@Len[%BBS] GT 0 If IsDir %BBS .AND. Exist %BBS\%InfoFile Copy/Q %BBS\%InfoFile
 Iff Not Exist %InfoFile Then
    Echo Door Info File not found! Please call Sysop voice IMMEDIATELY>%out
    Echo %Voice regardless of time and inform him!>%out
    Echo (Avoid dropping carrier if you can...)>%out
    Quit 200
 EndIff
:Lcl
 TW2002 -%InfoType
:
 Iff %? EQ 207 Then
:
: Code to do the Rift will go here.
:
:    Goto Lcl
 EndIff
:
 Goto Repack
:
:
:
: ͻ
:   Ŀ Ŀ Ŀ Ŀ Ŀ                                
:                                                                 
:                                                                 
:                                                                 
:        Ĵ                                                    
:                                                                 
:                                                                 
:                                                                 
:                                                           
: ͼ
: (Actual "Extern" Maintenance happens inside ListMSL)
:Maint
 Iff %MaintLoaded EQ N Then
    Echo Cannot locate MAINT.CFG or MAINT.%Game (searching entire path)
    Echo Using default settings.
 EndIff
 Call ListMSL
: Ŀ
: Some functions are dependent on the age of the game, so we'll go get it  
: 
 TED "G"
    Set Age=%@ReadScr[14,40,4]
: Ŀ
: Move &/or reset The Wanderer. Also handle The Crystalline Entity and The 
: Legion Death Star. Check up on evil StarShip captains and the Planetary  
: shield limiting, too. Don't forget to move the Nexus!                    
: 
: Wanderer:
 If %@ASCII[%Wanderer] NE 78 Call Wanderer MOVE
 Uns Wanderer WRDays
: The Legion Death Star
 Set Litter=N
 Set DStarAge=%@Eval[%Age-%DStar]
 Alias ;DSTAR 0
 Iff %DStarAge GT 0 .AND. %DStar NE -1 Then
    Rand^If %@Eval[%DSLitter+(%DStarAge*%DSLInc)] LE %Rnd Set Litter=Y
    Call DStar
 EndIff
 Uns DSLitter DSLInc DStar DStarAge Litter 
: The Crystalline Entity
 Iff Exist Entity.Stn Then
    If %@Eval[%@Date[%@FileDate[Entity.Stn]]-%@Date[%_Date]+%EntityStun] LE 0 Del/Q Entity.Stn
 EndIff
 If %Entity GT 0 .AND. Not Exist Entity.Stn Call Entity
 Uns Entity EntityCit EntityShlds EntityStun EntityMine EntityDStar
: Evil StarShip monitoring
 If %EvilISS GT 0 Call EvilISS
 Uns EvilISS EvilISSWeight
: Planetary Shields limiting
 If %@Len[%MaxSH] GT 0 If %MaxSH GE 0 .AND. %@Eval[%Age%%%4] Call ShldLimt %Ragnarok
: Nexus
 Iff %@Eval[%Age%%%%NexInterval] EQ 0 Then
    Rand^If %Rnd LE %NexAlter Call Nexus MOVE
 EndIff
 Uns Action Nexus NexNebula NexInterval NexAlter
: Ŀ
: Create a BLACK HOLE!                              As defined in MAINT.CFG
: A black hole is created by finding an empty sector then removing all exit
: warps from it. We also set the Nebula name to "Cygnus X-1" to warn Holo- 
: Scans. Density Scans find them as a sector with 0 warps.                  
: 
 Set BlackHole=N
 Iff %@Eval[%Age%%%%BlackHoleDays] EQ 0 .AND. %BlackHoleDays NE -1 Then
    Rand
    Iff %BlackHoleChance LT %Rnd Then
       EchoS Black Hole: 
       Call TWSector MSL DeadEnd
       Read Sector %_S
       CLog BLACK HOLE Sector %_S --- WarpList was %S_Warps
       SelectCase BlackHoleLog
          Case EQ Sector
             TLog Stellar collapse detected! Sector %_S is now a BLACK HOLE!
          Case EQ Warn
             TLog Stellar collapse detected! Be wary of the BLACK HOLE!
          Case EQ Silent
             CLog No warning posted.
          CaseElse
             Echo %BlackHoleLog not understood. Defaulting to "Sector".
             TLog Stellar collapse detected! Sector %_S is now a BLACK HOLE!
       EndSelect
       Build Sector %_S
          Add S_Nebula=Cygnus X-1
          Add S_Warps=0 0 0 0 0 0
       EndBuild
    EndIff
 EndIff
 Uns BlackHole BlackHoleDays BlackHoleChance
: Ŀ
: Create Rogue Fighters & Mines                               >= 60 days...
: 
 Iff %Age GE 60 .AND. %@ASCII[%Rogues] NE 78 Then
    Cls
    Echo Rogues:
    EchoS Fighters/Mines:
    Rand
    Iff %Rnd LE 0.0300 Then
       Set RLev=%@SubStr[%Rnd,3,2]^Set Mines=%RLev
       Set Ftrs=%@Eval[%RLev*%Age*3]^If Ftrs GT 30000 Set Ftrs=30000
       EchoS Which/Both?:
       Rand
       If %Rnd GT 0.8500 Set Mines=0
       If %Rnd LT 0.1500 Set Ftrs=0
       Call TWSector Ferrengal Empty NexusOK
       CLog %_Date Rogue Mines: %Mines  Fighters: %Ftrs  Sec: %_S
       Build Sector %_S
          Add S_Fighters=%Ftrs%00
          Add S_Fighters_Own=-2
          Add S_Mines=%Mines
       EndBuild
       TLog ~eRogue activity noted, sector %_S
    EndIff
 EndIff
: Ŀ
: Create Ferrengi Fighters & Mines                           (randomly)    
: 
 Iff %@ASCII[%Ferrengi] NE 78 Then
    Cls
    Echo Ferrengi:
    EchoS Fighters/Mines:^Rand
    Iff %Rnd LE 0.0300 Then
       Set RLev=%@SubStr[%Rnd,3,2]^Set Mines=%RLev
       Set Ftrs=%@Eval[%RLev*%Age*3]^If Ftrs GT 30000 Set Ftrs=30000
       EchoS Which/Both?:^Rand
       If %Rnd GT 0.8000 Set Mines=0
       If %Rnd LT 0.2000 Set Ftrs=0
       Call TWSector Ferrengal NexusOK
       Build Sector %_S
          Add S_Fighters=%Ftrs%00
          Add S_Fighters_Own=-1
          Add S_Mines=%Mines
       EndBuild
       TLog ~eFerrengi activity noted, sector %_S
    EndIff
 EndIff
 Uns Rogues Ferrengi RLev Mines Ftrs
 Cls^Echo Repacking...
 Goto Repack
:
:
:
:
:
:
:
:
:
:
:
:
:
:
:
:
:
: ͻ
:  Ŀ  Ŀ Ŀ Ŀ  Ŀ Ŀ Ŀ                 
:                                                             
:                                                               
:                                                               
:                  Ĵ                              
:                                                       
:                                                             
:                                                             
:                                   
: ͼ
:Setup
: Ŀ
: First, we be sure to keep the old configuration files, if any...         
: 
 If Not Exist Universe.Hld Del/Q TWData.Dat>&Nul 
 SelectCase CompUse
    Case EQ Y
       Iff Exist 2002-%Game.* Then
          %CompNot 2002-%Game *.Dat
          Del/QY 2002-%Game.*
       EndIff
    CaseElse
       Iff Exist %Game\*.Dat Then
          Copy/Q %Game\*.Dat
          If Not Exist %Game\Universe.Hld Del/QY %Game
       EndIff
       If Not IsDir %Game MD %Game
 EndSelect
 Iff Exist TWDATA.DAT Then
    Read Pilot 1
       Set RegCode="%P_Name"
    TED "G"
       Set TurnsDay=%@ReadScr[0,19,5]
       Set LogLines=%@ReadScr[7,40,3]
       Set UseCTS=%@ReadScr[17,40,1]
       Set LocalV=%@ReadScr[16,25,3]^If %LocalV EQ ON Set LocalView=Y^Uns LocalV
    TED "H"
       Set AMove=%@ReadScr[8,28,2]
       Set FMove=%@ReadScr[7,28,2]
       Set PhotonDur=%@ReadScr[14,23,2]
       Set Squatters=%@ReadScr[13,23,2]
       Set SysopLevel=%@ReadScr[10,23,5]
 EndIff
 Iff %@Len[%RegCode] EQ 0 Then
    Echo No Registration code available!
    PopD
    Quit 10
 EndIff
 Iff %CreateLoaded EQ N Then
    Echo Cannot locate BIGBANG.CFG &/or BIGBANG.%Game (searching entire path)
    Echo Using defaults...
    Set CreateLoaded=Y
 EndIff
: Ŀ
: Ok, NOW we go make a new universe!                                       
: 
 Echo %_Date>Creation.Dat
 If Exist 2002-%Game.* Del/Q 2002-%Game.*>&Nul
 BigBang
:Ŀ
: Get the DeadEnds.Dat file built...                                       
:
 Set S=11
 Cls
 EchoS Scanning for Dead Ends: 
:DeadEnd
   Screen 0 24 %S
   Read Sector %S
   Iff %@Word[1,%S_Warps] EQ 0 Then
      Read Sector %@Word[0,%S_Warps]
      If %@Index[%S_Warps,%S] NE -1 Echo %S>>DeadEnds.Dat
   EndIff
   Inc S
 Loop DeadEnd Until %S EQ 1001
: Ŀ
: Is Stardock shown on the "V" screen? (if so, we need to go add the       
: Major Space Lane beacons to the appropriate sectors)                     
: 
 Set StarDock=N
 EchoS Stardock?:
 Rand
 If %Rnd LE %VStarDock Set StarDock=Y
 Echo %StarDock
: Ŀ
: Enter TWs Registration Code and Stardock display setting                 
: 
: Build Pilot 1
:    Add P_Name=%RegCode
: EndBuild
 TED "G" 13 0 " Z" 13 0 %RegCode
 TED "H" 13 0 " M" 13 0 "%StarDock"
: Ŀ
: Place the Stardock, Class 0 Ports and Ferrengal in the Creation.Dat file:
: 
 TED "H"
    Set Ferrengal=%@ReadScr[3,30,3]
    Set Shipyards=%@ReadScr[4,30,3]
    Set PortZero2=%@ReadScr[5,30,3]
    Set PortZero3=%@ReadScr[6,30,3]
 For %%L in (Shipyards PortZero2 PortZero3 Ferrengal) Do CLog %[%L] %L
 CLog StarDock: %@ReadScr[12,23,1]
 Rand
 If %Rnd LT 0.0400 Set Squatters=0
 If %Rnd GT 0.8000 Set Squatters=2
: Ŀ
: Enter TWs General Settings Screen One & Two                              
: 
 TED "G" 13 0 " A" 13 0 "%TurnsDay"   13 0 "I" 13 0 "%LogLines"  13 0 /w20 "T" 13 0 "%UseCTS"    13 0 "S" 13 0 "%LocalView"
 TED "H" 13 0 " K" 13 0 "%SysopLevel" 13 0 "O" 13 0 "%Squatters" 13 0 /w20 "P" 13 0 "%PhotonDur" 13 0 "H" 13 0 "%FMove" 13 0 "I" 13 0 "%AMove"
 Uns TurnsDay LogLines UseCTS SysopLevel Squatters PhotonDur FMove AMove LocalView
: Ŀ
: Create and Stock The Wanderer & The Death Star                           
: 
 If %@ASCII[%Wanderer] NE 78 Call Wanderer CREATE
 Iff %DStar GT -1 Then
    Set Age=1
    Call DStar
 EndIff
: Ŀ
: Run Maint for the first time and grab/beacon(?) the Major Space Lanes.   
: 
 Call ListMSL
: Ŀ
: Random Planets?                                                          
: 
 Cls
 Iff %PMin GT 0 Then
    Set N=150
    EchoS How many random planets?:
    Rand
    Set Plan=%@Int[%@Eval[((%PMax-%PMin)*%Rnd)+%PMin-1]]
    CLog System-Generated Planets: %Plan
    Set Min=%@Eval[150-%Plan]
    Uns PMin Pmax Plan
    Iff %DStar GE 0 Then
       DecV Min 2
       Set N=148
       Goto/I Genesis
    EndIff
    If %@ASCII[%Wanderer] EQ 89 Then
       Dec Min
       Set N=149
    EndIff
   :Genesis
       Call Planet %N
       Dec N
    Loop Genesis While %N GE %Min
    Uns N Min
 EndIff
 MZ Ferrengi.Dat
 MZ Aliens.Dat
 MZ Travels.Dat
 MZ Avoids.Dat
: Ŀ
: Nexus?                                                                   
: 
 Iff %@Len[%Nexus] GE 1 If %Nexus GT 0.0000 Then
    Rand
    If %Rnd LE %Nexus Call Nexus Create
 EndIff
:  ͻ
:    Ŀ Ŀ Ŀ Ŀ                                       
:                                                                   
:                                                                   
:                                                                   
:                      Ĵ                                          
:                                                                   
:                                                                   
:                                                                   
:                                                   
:  ͼ
:
:Repack
 Echo Standby... Backing up data files!>%Out
 SelectCase CompUse
    Case EQ Y
       %CompUpd 2002-%Game
    CaseElse
       Copy/QU *.Dat %Game
 EndSelect
 Echo Done.  Returning to %BBSName>%Out
 ..
 PopD
 Quit 0
:  ͻ
:    Ŀ Ŀ Ŀ Ŀ Ŀ                               
:                                                                  
:                                                                  
:                                                                   
:                       Ĵ    Ŀ                               
:                                                                   
:                                                                  
:                                                                  
:                                                  
:  ͼ
ECHO REACHED NOTES! Something is wrong in a MAJOR way!
QUIT 255 (batch processing should NEVER reach this point!)

MACHINE SPEED:  (written, tested and used on a 386-20)
--------------
This will run as-is on a 386-20 or better.  The program tests your machine
speed itself and figures out the necessary waits on its own. (Almost to the
point I can trashcan this routine as superfluous.. ALMOST!)

BATCHFILES called:
------------------
RANDOM.BTM   - Random number generator
PLANET.BTM   - Create random Planet
TWSECTOR.BTM - Generate a Sector number within designated parameters
SHLDLIMT.BTM - Implement limiting of Planet Shielding levels
NEXUS.BTM    - Create, move or destroy a Nexus
WANDERER.BTM - Handles The Wanderer
DSTAR.BTM    - Handles The Death Star
ENTITY.BTM   - Runs The Crystalline Entity
LISTMSL.BTM  - Get the MSL listing. Runs EXTERN in the process, and Beacons
               the MSLs if need be as well

Other files expected: All are expected to be in %TWENH, including the ZIPs,
---------------------  (Don't want to use ZIP? Set comp* in TWFEAT! Don't want
---------------------   to compress at all? Set COMPUSE=N)
TWENH.CFG    - Primary information. Check out the contents listed below.
BIGBANG.CFG  - Settings used in universe creation.
MAINT.CFG    - Settings used only for maintenance.
TWENH.?      - Primary settings per game (optional - overrides/supplements .CFG)
BIGBANG.?    - Creation data per game (optional - overrides/supplements .CFG)
MAINT.?      - Maint data per game (optional - overrides/supplements .CFG)
PLANETS      - A list of made-up planet names. Feel free to add, delete, alter.
PLANET.CFG   - Planetary general settings
PLANET.LV?   - Settings for planets of each level
PLANET.WAN   - Settings for The Wanderer (uses PLANET.LV{wandlev} if absent)
2002-?.ZIP   - One zipfile per game. The "?" is the game letter and it contains
               all dynamic (changing) files (ie TWDATA.DAT) for that game.


Environment variables expected:
------------------------------
%TWEnh   - A directory pointer to locate the files of the TW2002 Enhancer.
%Games   - A list of characters possible as the 1st commandline parameter
           with a leading "garbage char" (ie Games avail are A-L on 
           Trader's World, %Games is xABCDEFGHIJKL). The order does not matter.
%BBS     - The directory where BBS files can be found. Only used to go get the
           Door Interface File if your BBS batch control didn't move it in and 
           I can't find it in the path.


4DOS.INI file should have:
 BatchEcho=NO
 Alias=860 (on top of whatever you already use!)
 Environment=3072 (on top of whatever you already use! I'm working on making
                    this a bit less of an environment hog, but...)

